local function Tab_OnClick(self)
	PanelTemplates_SetTab(self:GetParent())	
	
	QOLBloodTraderFrameTab1.content:Hide()
	QOLBloodTraderFrameTab2.content:Hide()
	self.content:Show()
end

local function SetTabs( frame, numTabs, ... )
	frame.numTabs = numTabs
	local contents = {}
	local frameName = frame:GetName()

	for i = 1, numTabs do
		local tab = CreateFrame("Button", frameName.."Tab"..i, frame, "CharacterFrameTabButtonTemplate")
		tab:SetID(i)
		tab:SetText(select(i, ...))
		tab:SetScript("OnClick", Tab_OnClick)

		tab.content = CreateFrame("Frame", nil, QOLBloodTraderFrame.ContentFrame)
		tab.content:SetPoint("TOPLEFT", QOLBloodTraderFrame.ContentFrame, "TOPLEFT")
		tab.content:SetSize(300, 350)
		tab.content:Hide()

		table.insert(contents, tab.content)

		if i == 1 then
			tab:SetPoint("TOPLEFT", QOLBloodTraderFrame, "BOTTOMLEFT", 5, 7)
		else
			tab:SetPoint("TOPLEFT", _G[frameName.."Tab"..(i-1)], "TOPRIGHT", -14, 0)
		end
	end

	Tab_OnClick(_G[frameName.."Tab1"])

	return unpack(contents)
end

local function CreateButton(parent, parent2, template, tooltip, width, height, price, hook1, hook2, offsetX, offsetY, texture, item)
	local button = CreateFrame("Button", nil, parent, template)
	button:SetPoint(hook1, parent2, hook2, offsetX, offsetY)
	button:SetSize(width, height)
	button:SetNormalFontObject("GameFontNormalLarge")
	button:SetHighlightFontObject("GameFontHighlightLarge")
	button:SetNormalTexture(texture)
	button.tooltipText = tooltip
	button:SetText(price)
	button:GetFontString():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -20, 2)
	button.bloodTexture = CreateFrame("Button", nil, button, "GameMenuButtonTemplate")
	button.bloodTexture:Show()
	button.bloodTexture:SetPoint("CENTER", button:GetFontString(), "CENTER", 13, 1)
	button.bloodTexture:SetSize(15, 15)
	button.bloodTexture:Disable()
	button.bloodTexture:SetDisabledTexture(GetItemIcon(124124)) -- blood icon

	button:SetScript("OnMouseDown", function(self, button) buy(item) end)
	return button
end

function InitQOLBloodTrader() 
  QOLBloodTraderFrame.title = QOLBloodTraderFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
  QOLBloodTraderFrame.title:SetPoint("CENTER", QOLBloodTraderFrameTitleBG, "CENTER", 0, 0)
  QOLBloodTraderFrame.title:SetText("Slarky's QOLBloodtrader")

  QOLBloodTraderFrame.ContentFrame = CreateFrame("Frame", nil, QOLBloodTraderFrame)
  QOLBloodTraderFrame.ContentFrame:SetSize(300, 350)
  QOLBloodTraderFrame.ContentFrame:SetPoint("TOPLEFT", QOLBloodTraderFrameDialogBG, "TOPLEFT", -3, 4)

  local content1, content2 = SetTabs(QOLBloodTraderFrame, 2, "Alchemy", "Cooking")

  local buttonX = 60
  local buttonY = 60

  local STRtooltip = "1x Flask of the Countless Armies"
  local INTtooltip = "1x Flask of the Whispered Pact"
  local AGItooltip = "1x Flask of the Seventh Demon"
  local STAtooltip = "1x Flask of Ten Thousand Scars"
  local WARtooltip = "1x Potion of the Old War"
  local UNBENDINGtooltip = "1x Unbending Potion"
  local GRACEtooltip = "1x Potion of Deadly Grace"
  local LEYtooltip = "1x Leytorrent Potion"

  local language = GetLocale()

  if language == "deDE" then
  	  STRtooltip = "1x Fläschchen der zahllosen Armeen"
	  INTtooltip = "1x Fläschchen des geflüsterten Pakts"
	  AGItooltip = "1x Fläschchen des Siebten Dämons"
	  STAtooltip = "1x Fläschchen der zehntausend Narben"
	  WARtooltip = "1x Trank des Alten Krieges"
	  UNBENDINGtooltip = "1x Unbeugsamer Trank"
	  GRACEtooltip = "1x Trank der tödlichen Anmut"
	  LEYtooltip = "1x Leywirbeltrank"
  end

  local blood_icon = GetItemIcon(124124)

  -- Create Buttons
  content1.FlaskSTRButton = CreateButton(content1, content1, 
  	"GameMenuButtonTemplate", STRtooltip, buttonX, buttonY, 5, "CENTER", "TOP", 
  	-65, -90, "Interface\\Icons\\inv_alchemy_70_flask03red", "STR")

  content1.FlaskINTButton = CreateButton(content1, content1.FlaskSTRButton, 
  	"GameMenuButtonTemplate", INTtooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03purple", "INT")

  content1.FlaskAGIButton = CreateButton(content1, content1.FlaskINTButton, 
  	"GameMenuButtonTemplate", AGItooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03orange", "AGI")

  content1.FlaskSTAButton = CreateButton(content1, content1.FlaskAGIButton, 
  	"GameMenuButtonTemplate", STAtooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03green", "STA")

  content1.FlaskWARButton = CreateButton(content1, content1, 
  	"GameMenuButtonTemplate", WARtooltip, buttonX, buttonY, 3, "CENTER", "TOP", 
  	buttonX, -90, "Interface\\Icons\\inv_alchemy_70_orange", "WAR")

  content1.FlaskUNBENDINGButton = CreateButton(content1, content1.FlaskWARButton, 
  	"GameMenuButtonTemplate", UNBENDINGtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask04", "UNBENDING")

  content1.FlaskGRACEButton = CreateButton(content1, content1.FlaskUNBENDINGButton, 
  	"GameMenuButtonTemplate", GRACEtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask02", "GRACE")

  content1.FlaskLEYButton = CreateButton(content1, content1.FlaskGRACEButton, 
  	"GameMenuButtonTemplate", LEYtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask01", "LEY")
end

function CheckBloodTrader()
  local BLOODTRADER_NPCID = 115264
  local guid = UnitGUID("npc")
  if not guid then return end
  local _, _, _, _, _, npcid = strsplit("-", guid)
  if not npcid then return end
  if tonumber(npcid) ~= BLOODTRADER_NPCID then return end
  QOLBloodTraderFrame:Show()
end

function closeIfOpen()
	QOLBloodTraderFrame:Hide()
end

function buy(item)
	if item == "STR" then
		BuyMerchantItem(18, 9)  -- Star
		BuyMerchantItem(14, 10) -- Aeth
		BuyMerchantItem(16, 10) -- Fox
	elseif item == "STA" then
		BuyMerchantItem(18, 9)  -- Star
		BuyMerchantItem(14, 10) -- Aeth
		BuyMerchantItem(15, 10) -- Dream
	elseif item == "AGI" then
		BuyMerchantItem(18, 9)  -- Star
		BuyMerchantItem(14, 10)
		BuyMerchantItem(17, 10) -- Fjarn
	elseif item == "INT" then
		BuyMerchantItem(18, 9)  -- Star
		BuyMerchantItem(17, 10) -- Fjarn
		BuyMerchantItem(15, 10) -- Dream
	elseif item == "WAR" then
		BuyMerchantItem(18, 3)  -- Star
		BuyMerchantItem(16, 10)  -- Fox
		BuyMerchantItem(17, 10)  -- Fjarn
	elseif item == "UNBENDING" then
		BuyMerchantItem(18, 3)  -- Star
		BuyMerchantItem(16, 10)  -- Fox
		BuyMerchantItem(14, 10)  -- Aeth
	elseif item == "GRACE" then
		BuyMerchantItem(18, 3)  -- Star
		BuyMerchantItem(17, 10)  -- Fjarn
		BuyMerchantItem(15, 10)  -- Dream
	elseif item == "LEY" then
		BuyMerchantItem(18, 3)  -- Star
		BuyMerchantItem(14, 10) -- Aeth
		BuyMerchantItem(15, 10) -- Dream
	end
end

MerchantFrame:SetScript("OnShow", CheckBloodTrader)
MerchantFrame:SetScript("OnHide", closeIfOpen)
